
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>URAL1119——DP——Metro / 憋错料</title>

    <meta name="description" content="URAL1119——DP——Metro Description Many of SKB Kontur programmers like to get to work by Metro because the main office is situated quite close the station Uralmash. So, since a sedentary life requires active exercises off-duty, many of the staff — Nikifor among them — walk">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">URAL1119——DP——Metro</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Description</p>
<p>Many of SKB Kontur programmers like to get to work by Metro because the main office is situated quite close the station Uralmash. So, since a sedentary life requires active exercises off-duty, many of the staff &mdash; Nikifor among them &mdash; walk from their homes to Metro stations on foot.</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYWNtLnRpbXVzLnJ1L2ltYWdlL2dldC5hc3B4LzhhZDUwZTJhLTJjYTItNDg5OC04N2Y0LTgzYzllOWQ3MGJlMw==.jpg" /></p>
<p>Nikifor lives in a part of our city where streets form a grid of residential quarters. All the quarters are squares with side 100 meters. A Metro entrance is situated at one of the crossroads. Nikifor starts his way from another crossroad which is south and west of the Metro entrance. Naturally, Nikifor, starting from his home, walks along the streets leading either to the north or to the east. On his way he may cross some quarters diagonally from their south-western corners to the north-eastern ones. Thus, some of the routes are shorter than others. Nikifor wonders, how long is the shortest route.</p>
<p>You are to write a program that will calculate the length of the shortest route from the south-western corner of the grid to the north-eastern one.</p>
<p>Input</p>
<p>There are two integers in the first line:&nbsp;<em>N</em>&nbsp;and&nbsp;<em>M</em>&nbsp;(0 &lt;&nbsp;<em>N</em>,&nbsp;<em>M</em>&nbsp;&le; 1000) &mdash; west-east and south-north sizes of the grid. Nikifor starts his way from a crossroad which is situated south-west of the quarter with coordinates (1, 1). A Metro station is situated north-east of the quarter with coordinates (&nbsp;<em>N</em>,&nbsp;<em>M</em>). The second input line contains a number&nbsp;<em>K</em>&nbsp;(0 &le;&nbsp;<em>K</em>&nbsp;&le; 100) which is a number of quarters that can be crossed diagonally. Then&nbsp;<em>K</em>&nbsp;lines with pairs of numbers separated with a space follow &mdash; these are the coordinates of those quarters.</p>
<p>Output</p>
<p>Your program is to output a length of the shortest route from Nikifor‘s home to the Metro station in meters, rounded to the integer amount of meters.</p>
<p>Sample Input</p>
<table>
<tbody>
<tr>
<th>input</th>
<th>output</th>
</tr>
<tr>
<td>
<pre>3 2
3
1 1
3 2
1 2
</pre>
</td>
<td>
<pre>383
</pre>
</td>
</tr>
</tbody>
</table>
<p>大意：求一点到另一点的最短路，精度好坑orz。。。开double就过了</p>
<p>就普通dp，弄好初始化的值，列好状态转移方程，确定终点三部曲</p>
<pre>#include&lt;cstdio&gt;
#include&lt;cstring&gt;
#include&lt;algorithm&gt;
#include&lt;cmath&gt;
using namespace std;
const int inf = 0x3f3f3f3f;
double dp[1005][1005];
int map1[1005][1005];
int main()
{
    int n,m,k,x,y;
    while(~scanf("%d%d",&amp;n,&amp;m)){
        scanf("%d",&amp;k);
        memset(map1,0,sizeof(map1));
        for(int i = 1; i &lt;= k ;i++){
            scanf("%d%d",&amp;x,&amp;y);
            map1[x+1][y+1] = 1;
        }
        for(int i = 0; i &lt;= n+1; i++)
            for(int j = 0; j &lt;= m+1; j++)
                dp[i][j] = inf;
        dp[1][1] = 0;
        for(int i = 1; i &lt;= n+1; i++){
            for(int j = 1 ; j &lt;= m+1 ;j++){
                if(i == 1 &amp;&amp; j == 1)
                    continue;
                if(map1[i][j] == 1)
                dp[i][j] = min(min(dp[i][j-1]+100,dp[i-1][j]+100),dp[i-1][j-1]+100*sqrt(2));
                else dp[i][j] = min(dp[i][j-1]+100,dp[i-1][j]+100);
            }
        }
        printf("%.0lf\n",dp[n+1][m+1]);
    }
return 0;
}
</pre>
<p>　　</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-12 18:13:03 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>URAL1119——DP——Metro的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bgGko3.html" rel="bookmark">UVA1025---A Spy in the Metro（DP&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://acm.hust.edu.cn/vjudge/problem/viewProblem.action?id=35913 Secret agent Maria was sent to Algorithms City to carry out an especially dangerous mission. Afterseveral thrilling events we ?nd her in the ?rst station of Algorithms City Metro, exam			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wERJZM.html" rel="bookmark">UVA 1025 A Spy in the Metro DP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				DP[ i ][ j ] 在 i 时刻 j 号车站的等待最小时间..... 有3种可能: 在原地等,坐开往左边的车,做开往右边的车 A Spy in the Metro Time Limit: 3000MS   Memory Limit: Unknown   64bit IO Format: %lld &amp; %llu Submit Status Description Secret agent Maria was sent to Algorithms City to carry out an es			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ORn5K0.html" rel="bookmark">UVA 1025 A Spy in the Metro（DP&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Secret agent Maria was sent to Algorithms City to carry out an especially dangerous mission. After several thrilling events we find her in the first station of Algorithms City Metro, examining the time table. The Algorithms City Metro consists of a s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JvvbA4.html" rel="bookmark">递推DP URAL 1119 Metro</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目传送门 1 /* 2 题意:已知起点(1,1),终点(n,m):从一个点水平或垂直走到相邻的点距离+1,还有k个抄近道的对角线+sqrt (2.0): 3 递推DP:仿照JayYe,处理的很巧妙,学习:) 4 好像还要滚动数组,不会,以后再补 5 */ 6 #include &lt;cstdio&gt; 7 #include &lt;iostream&gt; 8 #include &lt;algorithm&gt; 9 #include &lt;cmath&gt; 10 #include &lt;cs			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ME6gVy0.html" rel="bookmark">ural 1119  Metro   dp水</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				点击打开链接 1119. Metro Time limit: 0.5 second Memory limit: 64 MB Many of SKB Kontur programmers like to get to work by Metro because the main office is situated quite close the station Uralmash. So, since a sedentary life requires active exercises off-d			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz8bWW3.html" rel="bookmark">UVa 1025  A Spy in the Metro （DP动态规划）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题意:一个间谍要从第一个车站到第n个车站去会见另一个,在是期间有n个车站,有来回的车站,让你在时间T内时到达n,并且等车时间最短, 也就是尽量多坐车,最后输出最少等待时间. 析:这个挺复杂,首先时间是一个顺序,设d(i,j)表示时刻 i 在第 j 个车站,最少还要等待多长时间,那么边界是d(T, n) = 0. 并且有三种决策: 决策一:等着 d[i][j] = d[i + 1][j] + 1; 为什么从i + 1 过来呢? 你想一下,DP表示等待的时间,那么是不是应该倒着来呢? 决策二:有往右			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmDl1D4.html" rel="bookmark">UVA1025---A Spy in the Metro&lpar;简单dp&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				dp[i][j]表示时刻i,在车站j,等待的最少时间 有3种方案: 等一分钟 往左搭车 往右搭车 /************************************************************************* &gt; File Name: uva1025.cpp &gt; Author: ALex &gt; Mail: [email protected] &gt; Created Time: 2015年05月25日 星期一 19时05分09秒 ***********			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KOgkL0.html" rel="bookmark">Ural 1119 Metro（DP）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目地址:Ural 1119 因为还有一个可不可以穿的问题,所以需要再加一维.0代表可穿不可穿,可穿设置成0,不可穿就设置成无穷大.1代表当前这格的最短距离. 代码如下: #include &lt;iostream&gt; #include &lt;cstdio&gt; #include &lt;string&gt; #include &lt;cstring&gt; #include &lt;stdlib.h&gt; #include &lt;math.h&gt; #include &lt;ctype.h			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dDDve0.html" rel="bookmark">UVA 1025 A Spy in the Metro&lpar;DAG dp&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UVA 1025 1 #include&lt;cstdio&gt; 2 #include&lt;iostream&gt; 3 #include&lt;queue&gt; 4 #include&lt;vector&gt; 5 #include&lt;stack&gt; 6 #include&lt;set&gt; 7 #include&lt;string&gt; 8 #include&lt;cstring&gt; 9 #include&lt;math.h&gt; 10 #include&lt;algorith			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMgl1K0.html" rel="bookmark" class="title">hello world</a>
					<div>
						来个汇编版的hello world .section .data hello:     .ascii &quot;hello world\n&quot;     hello_len = . - hel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/949yd14.html" rel="bookmark" class="title">各种计时</a>
					<div>
						1.文字时间: window.onload=function(){                function todou(n){  //封装的补零函数                    if ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/W0jp594.html" rel="bookmark" class="title">sql语句的进化--hibernate篇</a>
					<div>
						Hibernate对JDBC进行了封装: 1)Hibernate属于持久层的框架(典型三层架构:表示层.业务层.持久层),其他的持久层比如myBatis等 2)hibernate是开源的一个ORM(对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/VMGWGVM.html" rel="bookmark" class="title">2016-03-09-阅读笔记： dump text &plus; report on MS ResNet &plus;  Deep feeling about DL</a>
					<div>
						1, 2014年的短文,今日看来无趣: link ＝ here 2,  关于ultra-deep network,a newsletter to KaiMing He's 152 layers Res ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knyrpM.html" rel="bookmark" class="title">防欺诈盗号请勿支付或输入qq密码</a>
					<div>
						本文介绍如何去除微信顶部的“防欺诈盗号.请勿支付或输入qq密码”.如图所示. 一.微信认证 目前只有已经通过微信认证的账号可以去除这个提示.在公众账号下左侧列表中找到微信认证,按照提示申请认证即可.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGEe5o3.html" rel="bookmark" class="title">setprecision &ast;&ast;fixed</a>
					<div>
						#include &lt;iostream&gt; #include &lt;iomanip&gt; using namespace std; int main( void ) { const dou ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWw8wGM.html" rel="bookmark" class="title">Java千百问&lowbar;01基本概念（003）&lowbar;J2EE里面的2是什么意思</a>
					<div>
						点击进入_更多_Java千百问 1.J2EE里面的2是什么意思 J2SE,J2SE,J2ME中2的含义要追溯要1998年. 1998年Java 1.2版本发布,1999年发布Java 1.2的标准版, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPdx61M.html" rel="bookmark" class="title">批量插入 SqlBulkCopy的测试</a>
					<div>
						关于SqlBulkCopy的测试 最近要做.net关于sql大量插入,找到了sqlbulkcopy(自己google下,应该很多说明了)这个好东西,于是测试下性能,用了三个方法对比: 1)直接用ado ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXeDj3.html" rel="bookmark" class="title">shell jsonj解析</a>
					<div>
						Jshon的安装需要Jansson支持:http://www.digip.org/jansson/ # wget http://www.digip.org/jansson/releases/janss ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWAjRy3.html" rel="bookmark" class="title">Mac、Linux更换命令行svn diff为P4Merge、vimdiff</a>
					<div>
						2015-01-21 21:25:52 这里先把那个程序员大神的博客地址贴一下(PS:大神,我不是为了抄袭哦,真是怕自己忘记了),http://www.ccvita.com/445.html,里面还有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K2PoLM.html" rel="bookmark" class="title">C&plus;&plus;自学笔记&lowbar;特殊的成员变量的初始化方法&lowbar;《C&plus;&plus; Primer》</a>
					<div>
						有些成员变量的数据类型比较特别,它们的初始化方式也和普通数据类型的成员变量有所不同.这些特殊的类型的成员变量包括: a.引用 b.常量 c.静态 d.静态常量(整型) e.静态常量(非整型) 常量和引 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8DNd3.html" rel="bookmark" class="title">BZOJ 3110 &lbrack;Zjoi2013&rsqb;K大数查询 &mdash;&mdash;整体二分</a>
					<div>
						[题目分析] 整体二分显而易见. 自己YY了一下用树状数组区间修改,区间查询的操作. 又因为一个字母调了一下午. 貌似树状数组并不需要清空,可以用一个指针来维护,可以少一个log 懒得写了. [代码] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ZarB0.html" rel="bookmark" class="title">Hadoop 管理工具HUE配置-集成Unix用户和用户组</a>
					<div>
						HUE安装完成之后,第一次登录的用户就是HUE的超级用户,可以管理用户,等等.但是在用的过程发现一个问题这个用户不能管理HDFS中由supergroup创建的数据. 虽然在HUE中创建的用户可以管理自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6kwR0.html" rel="bookmark" class="title">JNI 概述【转】</a>
					<div>
						本文转载自:http://wiki.jikexueyuan.com/project/jni-ndk-developer-guide/overview.html 相信很多做过 Java 或 Androi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNaeX4.html" rel="bookmark" class="title">CSS&plus;DIV网页样式与布局&mdash;&mdash;文字样式&amp;amp&semi;段落（一）</a>
					<div>
						一个网页要说最多的还是文字,上篇博客说CSS样式是一个网页的精髓,那网页中最直接表现出来的就是文字和图片,还有一些所谓的表单,首先先说最为熟悉和常用的文字.让CSS控制网页中的文字,使它不再那么枯燥平 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v1vvg0.html" rel="bookmark" class="title">计算机系统要素：第十一章 编译器：代码生成</a>
					<div>
						一,项目介绍 终于来到了编译器部分的最后一个章节--代码生成阶段.本章的目标就是将Jack语言转化为VM语言,完成Jack编译器的构建. 刚刚接触这章的内容时,会比较难上手,最主要的问题就在于,这章的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Opygr4.html" rel="bookmark" class="title">Maximum Product of Three Numbers</a>
					<div>
						这道题为简单题 题目: 思路: 其实这个题主要是需要注意负数的问题,首先我把列表进行排序,可能有人到这个会有多种考虑,但是实际上返回最大值的情况只有两种,(1).列表最开始两个元素乘以最后的一个元素: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AaBVD4.html" rel="bookmark" class="title">jquery插件简单的声明方法</a>
					<div>
						(function($){     //  声明插件内容     $.fn.pluginName = function(options){         //  默认插件配置         var ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kwjaE0.html" rel="bookmark" class="title">MSSQL Server 数据库备份还原常用SQL语句及注意</a>
					<div>
						1.备份数据库 backup database db_name to disk='d:\db_name.bak' with format --通过使用with format可以做到覆盖任何现有的备份和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35n7Qn4.html" rel="bookmark" class="title">Mysql函数FIND&lowbar;IN&lowbar;SET&lpar;&rpar;的使用方法</a>
					<div>
						有了FIND_IN_SET这个函数.我们可以设计一个如:一只手机即是智能机,又是Andriod系统的. 比如:有个产品表里有一个type字段,他存储的是产品(手机)类型,有 1.智能机,2.Andri ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
